#ifndef __CFS_H__
#define __CFS_H__


#include "asn1.h"

/*
** Instance structure
*/

typedef struct _cfs_t {

	CFSObject_ASN1module_CfsId cfsId ;
	CFSObject_ASN1module_CfsDirectory cfsName ;
	CFSObject_ASN1module_AutoUpdate cfsAutoUpdate ;
	ca_binding_t *nameBinding ;
	OM_boolean packagesPresent ;
	Attribute_ASN1Module_Packages packages ;
	OM_boolean allomorphsPresent ;
	Attribute_ASN1Module_Allomorphs allomorphs ;

	/* Notifications management */
	char * attrValChngLst ;

} cfs_t ;


extern OM_return_code cfs_init(
	ca_context_t	*context,
	void		*sup,
	void		**current
) ;

extern OM_return_code cfs_create(
	ca_context_t	*context,
	void		*caSupRef,
	ca_binding_t	*binding,
	OM_descriptor	*localName,
	void		**caRef,
	void		**accessRef,
	OM_descriptor	*error
) ;

extern OM_return_code cfs_delete(
	ca_context_t	*context,
	OM_sint32	invokeId,
	OM_boolean	type,
	void		*usrRef,
	void		*caRef,
	void		*accessRef
) ;

extern OM_return_code cfs_free_instance(
	ca_context_t *context,
	void *caRef,
	void *usrRef
) ;

extern OM_return_code cfs_check(
	ca_context_t	*context,
	OM_sint		oper,
	void		*caRef,
	void		*usrRef
) ;

extern OM_return_code cfs_cfsId_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_cfsId_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfs_cfsId_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfs_cfsName_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_cfsName_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfs_cfsName_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfs_cfsAutoUpdate_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_cfsAutoUpdate_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfs_cfsAutoUpdate_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfs_objectClass_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_nameBinding_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_packages_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_packages_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfs_packages_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfs_allomorphs_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfs_allomorphs_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfs_allomorphs_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfs_cfsUpdateSystem(
	ca_context_t	*context,
	OM_sint32	invokeId,
	OM_uint	mode,
	OM_descriptor	*actionInfoArg,
	void		*usrRef,
	void		*accessRef
) ;



#endif /* __CFS_H__ */

