/****************************************************************************/
/*  File Name: 		dmi_config.c                                        */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  Description:                                                            */
/*  -----------                                                             */
/*      The present file contains definitions of the notifications supported*/
/*      by the dmi library and its discrimination mechanism                 */
/*                                                                          */
/****************************************************************************/


/*--------------------------------------------------------------------------*/
/*                               STANDARD INCLUDE                           */
/*--------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>

/*--------------------------------------------------------------------------*/
/*                                 TMN INCLUDE                              */
/*--------------------------------------------------------------------------*/
#ifdef WIN32
#include <xom.h>
#include <usr_caDefs.h>
#include <usr_caNoti.h>
#else /* WIN32 */
#include <cmip/xom.h>
#include <tmn_agent/usr_caDefs.h>
#include <tmn_agent/usr_caNoti.h>
#endif /* WIN32 */


extern ca_generic_attribute_t  att_g_sourceIndicator[];
extern ca_generic_attribute_t  att_g_notificationIdentifier[];
extern ca_generic_attribute_t  att_g_attrValChngDef[];
extern ca_generic_attribute_t  att_g_probableCause[];
extern ca_generic_attribute_t  att_g_perceivedSeverity[];
extern ca_generic_attribute_t  att_g_backedUpStatus[];
extern ca_generic_attribute_t  att_g_backUpObject[];
extern ca_generic_attribute_t  att_g_trendIndication[];

extern ca_gdmo_notif_t  clas_p_attributeValueChange [];
extern ca_gdmo_notif_t  clas_p_commsAlarm [];
extern ca_gdmo_notif_t  clas_p_envAlarm [];
extern ca_gdmo_notif_t  clas_p_equipAlarm [];
extern ca_gdmo_notif_t  clas_p_objectCreation [];
extern ca_gdmo_notif_t  clas_p_objectDeletion [];
extern ca_gdmo_notif_t  clas_p_procErrAlarm [];
extern ca_gdmo_notif_t  clas_p_qualSvceAlarm [];
extern ca_gdmo_notif_t  clas_p_relationChange [];
extern ca_gdmo_notif_t  clas_p_stateChange [];


ca_gdmo_notif_t *listOfPseudoClass[]= {
	clas_p_attributeValueChange,
	clas_p_objectCreation,
	clas_p_objectDeletion,
	clas_p_stateChange,
	clas_p_relationChange,
	clas_p_procErrAlarm,
	clas_p_equipAlarm,
	clas_p_qualSvceAlarm,
	clas_p_commsAlarm,
	clas_p_envAlarm,
	NULL
	};

ca_generic_attribute_t *listOfGenericAtt[]= {
	att_g_sourceIndicator,
	att_g_notificationIdentifier,
        att_g_attrValChngDef,
	att_g_probableCause,
	att_g_perceivedSeverity,
	att_g_backedUpStatus,
	att_g_backUpObject,
	att_g_trendIndication,
	NULL
	};
