#ifndef __SYSTEM_H__
#define __SYSTEM_H__


#include "asn1.h"

/*
** Instance structure
*/

typedef struct _system_t {

	Attribute_ASN1Module_SystemId systemId ;
	Attribute_ASN1Module_SystemTitle systemTitle ;
	Attribute_ASN1Module_OperationalState operationalState ;
	Attribute_ASN1Module_UsageState usageState ;
	ca_binding_t *nameBinding ;
	OM_boolean administrativeStatePresent ;
	Attribute_ASN1Module_AdministrativeState administrativeState ;
	OM_boolean supportedFeaturesPresent ;
	Attribute_ASN1Module_SupportedFeatures supportedFeatures ;
	OM_boolean packagesPresent ;
	Attribute_ASN1Module_Packages packages ;
	OM_boolean allomorphsPresent ;
	Attribute_ASN1Module_Allomorphs allomorphs ;

} system_t ;


extern OM_return_code system_init(
	ca_context_t	*context,
	void		*sup,
	void		**current
) ;

extern OM_return_code system_check(
	ca_context_t	*context,
	OM_sint		oper,
	void		*caRef,
	void		*usrRef
) ;

extern OM_return_code system_systemId_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_systemId_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_systemTitle_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_systemTitle_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_operationalState_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_operationalState_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_usageState_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_usageState_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_objectClass_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_nameBinding_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_administrativeState_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_administrativeState_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code system_administrativeState_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_supportedFeatures_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_supportedFeatures_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code system_supportedFeatures_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_packages_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_packages_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code system_allomorphs_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code system_allomorphs_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;



#endif /* __SYSTEM_H__ */

