#ifndef __CFSFILE_H__
#define __CFSFILE_H__


#include "asn1.h"

/*
** Instance structure
*/

typedef struct _cfsFile_t {

	CFSObject_ASN1module_CfsId cfsId ;
	CFSObject_ASN1module_FilePermissions cfsFilePermissions ;
	ca_binding_t *nameBinding ;
	OM_boolean packagesPresent ;
	Attribute_ASN1Module_Packages packages ;
	OM_boolean allomorphsPresent ;
	Attribute_ASN1Module_Allomorphs allomorphs ;

	/* Notifications management */
	char * attrValChngLst ;

} cfsFile_t ;


extern OM_return_code cfsFile_init(
	ca_context_t	*context,
	void		*sup,
	void		**current
) ;

extern OM_return_code cfsFile_create(
	ca_context_t	*context,
	void		*caSupRef,
	ca_binding_t	*binding,
	OM_descriptor	*localName,
	void		**caRef,
	void		**accessRef,
	OM_descriptor	*error
) ;

extern OM_return_code cfsFile_delete(
	ca_context_t	*context,
	OM_sint32	invokeId,
	OM_boolean	type,
	void		*usrRef,
	void		*caRef,
	void		*accessRef
) ;

extern OM_return_code cfsFile_free_instance(
	ca_context_t *context,
	void *caRef,
	void *usrRef
) ;

extern OM_return_code cfsFile_check(
	ca_context_t	*context,
	OM_sint		oper,
	void		*caRef,
	void		*usrRef
) ;

extern OM_return_code cfsFile_cfsId_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsFile_cfsId_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsFile_cfsId_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsFile_cfsFilePermissions_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsFile_cfsFilePermissions_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsFile_cfsFilePermissions_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsFile_objectClass_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsFile_nameBinding_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsFile_packages_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsFile_packages_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsFile_packages_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsFile_allomorphs_get(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value
) ;

extern OM_return_code cfsFile_allomorphs_set(
	ca_context_t	*context,
	OM_enumeration	modifyOperator,
	OM_descriptor	*valueForOperation,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*resultingValue
) ;

extern OM_return_code cfsFile_allomorphs_eval(
	ca_context_t	*context,
	void		*usrRef,
	void		*accessRef,
	OM_descriptor	*value1,
	OM_descriptor	*value2,
	OM_type		type,
	OM_boolean	*result,
	OM_boolean	*error
) ;

extern OM_return_code cfsFile_cfsUpdateFile(
	ca_context_t	*context,
	OM_sint32	invokeId,
	OM_uint	mode,
	OM_descriptor	*actionInfoArg,
	void		*usrRef,
	void		*accessRef
) ;


/*
** Function added for example purposes
*/

OM_return_code cfsFile_createFile(
	char 		*path
) ;

OM_return_code cfsFile_removeFile(
	ca_context_t 	*context,
	void		*usrRef
) ;

#endif /* __CFSFILE_H__ */

